﻿-- Author      : Skylar
-- Last Updated : 7/14/2012 10:54 AM
function SkyUI_CreateClass(parent)
	local class = { prototype = {} }
	if parent then
		class.super = parent
		setmetatable(class.prototype, { __index = parent.prototype })
	end
	local mt = { __index = class.prototype }
	function class:new(...)
		local self = setmetatable({}, mt)
		if self.init then
			self:init(...)
		end
		return self
	end

	return class
end


SkyUI = {}
local SkyUI = SkyUI

function SkyUI.tcopy(to, from)   -- "to" must be a table (possibly empty)
 for k,v in pairs(from) do
  if(type(v)=="table") then
   to[k] = {}
   SkyUI.tcopy(to[k], v)
  else to[k] = v end
 end
end

SkyUI.Modules = { UnitFrames = { Initialized = false, Enabled = false }, ActionBars = { Initialized = false, Enabled = false }, ComboPoints = { Initialized = false, Enabled = false }, Main = {} }

SkyUI.Graphics = { -- Textures
 Btn =	{ Path = "Interface\\addons\\SkyUI\\Textures\\SkyUI", W = 512, H = 512 },
	Units = { Path = "Interface\\addons\\SkyUI\\Textures\\SkyUI_unitFrames", W = 512, H = 512 },
}

SkyUI.Fonts = {
 Memoe = "Interface\\addons\\SkyUI\\Fonts\\MEMOE___.ttf",
	Nasalization = "Interface\\addons\\SkyUI\\Fonts\\nasalization.ttf",
	OrbitronBlack = "Interface\\addons\\SkyUI\\Fonts\\orbitron-black.ttf",
	OrbitronBold = "Interface\\addons\\SkyUI\\Fonts\\orbitron-bold.ttf",
	OrbitronLight = "Interface\\addons\\SkyUI\\Fonts\\orbitron-light.ttf",
	OrbitronMedium = "Interface\\addons\\SkyUI\\Fonts\\orbitron-medium.ttf",	
}
SkyUI.Clr = {
	None = {r = 1, g = 1, b = 1, a = 1},
	HealthFriendly = {r = 0, g = 1, b = 0.125, a = 1},
	HealthIncoming = {r = 0, g = .5, b = .075, a = 1},
	HealthHostile = {r = 0.95, g = 0.05, b = 0.05, a = 1},
	HealthHostileIncoming = {r = 0.75, g = 0.05, b = 0.05, a = 1},
	HealthNeutral = {r = 0.8, g = 0.8, b = 0.8, a = 1},
	Mana = {r = 0, g = 0.72265625, b = 0.92578125, a = 1},
	Energy = {r = 1, g = 1, b = 0, a = 1},
	Combo = {r = 1, g = 1, b = 0, a = 0},
	Transparent = {r = 1, g = 1, b = 1, a = 0},
	Debuff = {r = 0.5, g = 0, b = 1},
}
local Clr = SkyUI.Clr

SkyUI.Config = {}
SkyUI.ConfigDefaults = {
 UnitFrames = {
  UI =              { Enabled = true, OffsetX = 0, OffsetY = 0,  player = { Enabled = true }, target = { Enabled = true, }, },
  Auras =           { Enabled = true, AuraBarsEnabled = true, MaxAuraBars = 8, },

  playerpet =       { Enabled = true },
  playerpettarget = { Enabled = true },
  targetpet =       { Enabled = true, },
  targetpettarget = { Enabled = true, },
  focus =           { Enabled = true, },
  targettarget =    { Enabled = true, },


 },
 ActionBars = {
  UI =               { Enabled = true, HotKeys = false, MacroText = false, ItemCount = false, },
  KeyPad =           { Enabled = true, OffsetX = 0, OffsetY = 0 },
  ArrowPad =         { Enabled = true, OffsetX = 0, OffsetY = 0 },
  VertBar =          { Enabled = true, OffsetX = 0, OffsetY = 0 },
  MainBar =          { Enabled = true, OffsetX = 0, OffsetY = 0 },
  MicroMenu =        { Enabled = true, OffsetX = 0, OffsetY = 0 },
  PetBar =           { Enabled = true, OffsetX = 0, OffsetY = 0 },
 },
 ComboPoints = {
  Enabled = false, OffsetX = 0, OffsetY = 0
 },
}
SkyUI.tcopy(SkyUI.Config, SkyUI.ConfigDefaults)

SkyUI.Specs = {
-- "Enabled" settings not yet functional, requires setting up an options menu.. long work ahead..
	ActionBars = {
  Enabled = true,
  TextureSheet = SkyUI.Graphics.Btn, 
  KeyPad = {
   Enabled = true;
 		bgTexture = { X = 0, Y = 0 },
 		RT = "RIGHT", X = -200, Y = 0, W = 131, H = 164,
 	},
  ArrowPad = {
   Enabled = true;
 		bgTexture = { X = 0,	Y = 164	},
 		RT = "RIGHT",	X = -200,	Y = -200,	W = 98,	H = 132,
 	},
  VertBar = {
   Enabled = true;
 		bgTexture = { X = 466,	Y = 50 },
 		RT = "RIGHT", X = -10, Y = 0, W = 32, H = 395,
 	},
  MainBar = {
   Enabled = true;
 		bgTexture = { X = 3, Y = 444, W = 447, H = 49 },
 		RT = "BOTTOM", X = 0, Y = 20, W = 447, H = 49,
 		Textures = { -- Graphic, RelativeTo, offsetX, offsetY, texturecoordX, texturecoordY, Width, Height
 			["XPBarLeft"] = { RT = "BOTTOMLEFT", X = 5, Y = 4, tX = 7, tY = 498, W = 3, H = 7, L = "ARTWORK" },
 			["XPBarSpan"] = { RT = "BOTTOMLEFT", X = 8, Y = 4, tX = 10, tY = 498, W = 1, H = 7, L = "ARTWORK" },
 			["XPBarRight"] = { RT = "BOTTOMLEFT", X = 100, Y = 4, tX = 22, tY = 498, W = 3, H = 7, L = "ARTWORK" },
 		},
 		Text = {
 			["UIName"] = { String = "SkyUI", RT = "BOTTOM", X = 1, Y = 28.5, Font = SkyUI.Fonts.OrbitronBlack, Size = 10, Flags = "" }
 		},
 	},
  MicroMenu = {
   Enabled = true;
   bgTexture = nil,
--   RT = "BOTTOMRIGHT", X = -8, Y = 4, W = 257, H = 41,
   RT = "BOTTOMRIGHT", X = -30, Y = 4, W = 279, H = 41,
  },
  PetBar = {
   Enabled = true;
   bgTexture = nil,
   RT = "BOTTOM", X = 0, Y = 90, W = 350, H = 41,
  },
	},
	UnitFrames = {
	-- "Enabled" settings not yet functional, requires setting up an options menu.. long work ahead..
  Enabled = true,
 	TextureSheet = SkyUI.Graphics.Units,
		TextureOffset = {X = -36, Y = 111}, -- Location of frame textures in relation to the spritesheet being used
  Frames = { --[ Anchor, OffsetX, OffsetY, Width, Height, X1,X2,Y1,Y2 ] :: Hitbox for the unit frames
   Player = { RT = "CENTER", X = -250, Y = -100, W = 70, H = 45 }, -- 230
   Target = { RT = "CENTER", X = 250, Y = -100, W = 70, H = 45 }, -- 222
--   Party = {	bgTexture = { X = 0, Y = 0 },	RT = "TOPLEFT", X = 20, Y = 150, W = 140, H = 37, tX = 289, tY = 162	},
  },
  Unit = { -- Unit Frame Setup
			Textures = {
			 -- [ OffsetX, OffsetY, X, Y, Width, Height, Layer, DefaultVertexColor ]
   -- 181,267
    BG = { X = 0, Y = 0.5, tX = 0, tY = 0, W = 206, H = 269, L = "BACKGROUND" },
		
    Health = { X = 3, Y = -6.5, tX = 221, tY = 7, W = 143, H = 164, L = "ARTWORK", Clr = Clr.HealthFriendly },
    IncomingHealth = { X = 3, Y = -6.5, tX = 221, tY = 7, W = 143, H = 164, L = "BORDER", Clr = Clr.HealthIncoming },

    Power = { X = 79.5, Y = -160, tX = 79, tY = 268, W = 86, H = 86, L = "ARTWORK", Clr = Clr.Energy },

 		 CastBar = { X = 150, Y = -179.5, tX = 0,tY =  374, W = 169, H = 23, L = "BACKGROUND" },
 		 Cast = { X = 156.5, Y = -185.5, tX = 6, tY = 397, W = 139, H = 11, L = "ARTWORK" },
    CastIconOverlay = { X = 294.5, Y = -183.5, tX = 169, tY = 376, W = 17, H = 17, L = "ARTWORK" },

 		 NameSpannerL = { X = 151.5, Y = -182.5, tX = 222, tY = 184, W = 15, H = 18, L = "BACKGROUND" },
 		 NameSpannerS = { X = 166.5, Y = -182.5, tX = 241, tY = 184, W = 1, H = 18, L = "BACKGROUND" },
 		 NameSpannerR = { X = 167.5, Y = -182.5, tX = 242, tY = 184, W = 15, H = 18, L = "BACKGROUND" },

    ClassColorStrip = { X = 163, Y = -203.5, tX = 222, tY = 204, W = 41, H = 13, L = "ARTWORK" },
				
				BuffBar = { Skip = true, X = 37, Y = -33.5, tX = 318, tY = 268, W = 128, H = 112, L = "BACKGROUND", Clr.None},
    Buff = { Skip = true, X = 45, Y = -36.5, tX = 326, tY = 380, W = 101, H = 101, L = "ARTWORK", Clr.None},

				DebuffBar = { Skip = true, X = 90, Y = -191.5, tX = 222, tY = 268, W = 97, H = 81, L = "BACKGROUND", Clr.None},
    Debuff = { Skip = true, X = 97, Y = -194.5, tX = 240, tY = 380, W = 70, H = 70, L = "ARTWORK", Clr.None},

 			AuraBuff = { Skip = true, X = 149, Y = -146.5, tX = 302, tY = 333, W = 15, H = 15, L = "BACKGROUND" },
-- 			AuraDebuff = { Skip = nil, X = 149, Y = -163.5, tX = 302, tY = 333, W = 15, H = 15, L = "BACKGROUND" },

 			AuraDebuff = { Skip = true, X = 170, Y = -240.5, tX = 302, tY = 333, W = 15, H = 15, L = "BACKGROUND" },
-- 			Aura4 = { Skip = nil, X = 170, Y = -223.5, tX = 302, tY = 333, W = 15, H = 15, L = "BACKGROUND" },
-- 			Aura5 = { Skip = nil, X = 170, Y = -206.5, tX = 302, tY = 333, W = 15, H = 15, L = "BACKGROUND" },

--    PetBG = { X = 200, Y = 240.5, tX = 372, tY = 142, W = 111, H = 29, L = "BACKGROUND" },


    PetBG = { X = 200, Y = -280.5, tX = 372, tY = 142, W = 111, H = 29, L = "BACKGROUND" },
    PetHealth = { X = 228, Y = -293.5, tX = 400, tY = 127, W = 80, H = 8, L = "ARTWORK", Clr = Clr.HealthFriendly },
    PetPower = { X = 228, Y = -302.5, tX = 400, tY = 136, W = 80, H = 4, L = "ARTWORK", Clr = Clr.Energy }, -- change to transparent!

    PetTargetBG = { X = 200, Y = -347.5+36, tX = 372, tY = 65, W = 111, H = 29, L = "BACKGROUND" },
    PetTargetHealth = { X = 228, Y = -350.5+36, tX = 400, tY = 127, W = 80, H = 8, L = "ARTWORK", Clr = Clr.HealthHostile },
    PetTargetPower = { X = 228, Y = -359.5+36, tX = 400, tY = 136, W = 80, H = 4, L = "ARTWORK", Clr = Clr.Energy },

    TargetOrFocusBG = { X = -35, Y = -165.5, tX = 372, tY = 96, W = 111, H = 29, L = "BACKGROUND" }, 
    TargetOrFocusHealth = { X = -32, Y = -178.5, tX = 400, tY = 127, W = 80, H = 8, L = "ARTWORK", Clr = Clr.HealthNeutral },
    TargetOrFocusPower = { X = -32, Y = -187.5, tX = 400, tY = 136, W = 80, H = 4, L = "ARTWORK", Clr = Clr.Energy },

    RareElite = { Skip = true, X = 165, Y = -90.5, tX = 372, tY = 3, W = 80, H = 13, L = "ARTWORK", Clr.None},
    Boss =      { Skip = true, X = 165, Y = -90.5, tX = 372, tY = 18, W = 55, H = 13, L = "ARTWORK", Clr.None},
    Elite =     { Skip = true, X = 165, Y = -90.5, tX = 372, tY = 33, W = 51, H = 13, L = "ARTWORK", Clr.None},
    Rare =      { Skip = true, X = 165, Y = -90.5, tX = 372, tY = 48, W = 53, H = 13, L = "ARTWORK", Clr.None},
    
			},
			Text = {
 			["UnitName"] = { String = "", X = 167.5, Y = -186.5, Font = SkyUI.Fonts.OrbitronBlack, Size = 10, Flags = "" },
 			["UnitLevel"] = { String = "1", X = 165, Y = -204 , Font = SkyUI.Fonts.Nasalization, Size = 12, Flags = "OUTLINE" },

    ["PetName"] = { String = "PetName", X = 229, Y = -285, Font = SkyUI.Fonts.OrbitronLight, Size = 8, Flags = "" },
    ["PetTargetName"] = { String = "PetTargetName", X = 229, Y = -365+35, Font = SkyUI.Fonts.OrbitronLight, Size = 8, Flags = "" },
    ["TargetOrFocusName"] = { String = "TargetOrFocusName", X = 49, Y = -170 , Font = SkyUI.Fonts.OrbitronLight, Size = 8, Flags = "", ReversePosition = true },

 		},
  },	
	},
 ComboPoints = {
 -- "Enabled" settings not yet functional, requires setting up an options menu.. long work ahead.. Combo Points not yet functional either.. hate how my graphics look atm!
  Enabled = false,
  TextureSheet = SkyUI.Graphics.Units,
		TextureOffset = {X = 0, Y = 0},
  Frames = { --[ Anchor, OffsetX, OffsetY, Width, Height, X1,X2,Y1,Y2 ]
   Combo = { RT = "CENTER", X = 0, Y = -220, W = 72, H = 72  },
  },
  Textures = {
   BG = { X = 0, Y = 0.5, tX = 5, tY = 408, W = 72, H = 72, L = "BACKGROUND" },
 	 C1 = { X = 0, Y = -16, tX = 113, tY = 408, W = 35, H = 35, L = "OVERLAY", Sub = 0, Clr = Clr.Combo, Rotate = 3 },
 	 C2 = { X = 21, Y = 0, tX = 113, tY = 408, W = 35, H = 35, L = "OVERLAY", Sub = 0, Clr = Clr.Combo, Rotate = 0 },
 	 C3 = { X = 37, Y = -21, tX = 113, tY = 408, W = 35, H = 35, L = "OVERLAY", Sub = 0, Clr = Clr.Combo, Rotate = 1},
 	 C4 = { X = 16, Y = -37, tX = 113, tY = 408, W = 35, H = 35, L = "OVERLAY", Sub = 0, Clr = Clr.Combo, Rotate = 2 },
 	 C5 = { X = 22, Y = -22, tX = 113, tY = 452, W = 28, H = 28, L = "OVERLAY", Sub = 1, Clr = Clr.Combo},
  }
 
 },

}


SkyBaseClass = SkyUI_CreateClass()
local SkyBaseClass = SkyBaseClass

SkyBaseClass.prototype.BaseName = "SkyUI_"

-- SkyBaseClass.Evt = CreateFrame("Frame") -- Event Catcher Frame

-- TexturePath, TextureSize, TextureCoordX, TextureCoordY

function SkyBaseClass.prototype:init()
end


function SkyBaseClass.prototype:SetBackground()
 if not self.bgTexture or not self.F then return end

	local t = self.bgTexture
	local g = self.TS
 local bg = self.F:CreateTexture(nil, "BACKGROUND")
	bg:SetTexture(g.Path) -- SpriteSheet
	bg:SetAllPoints(self.F)
	bg:SetTexCoord(t.X / g.W, (t.X + self.W) / g.W, t.Y / g.H, (t.Y + self.H) / g.H)

	bg:Show()
    self.F.texture = bg
	
	self.F:Show()

end

function SkyBaseClass.prototype:Disable()
 if self.F then self.F:Hide() end
end

function SkyBaseClass.prototype:Enable()
 if self.F then self.F:Show() end
end



function SkyBaseClass.prototype:AddTextures(Textures)
 if not self.T or not self.F then return end
	local g = self.TS

 if not Textures then Textures = self.T end
	
	for k,v in pairs(Textures) do
	 if not v.Skip then
	  self.F[k] = self.F:CreateTexture(self.BaseName .. self.Name .. k, v.L, nil, v.Sub)
   self.F[k]:SetTexture(g.Path)
			
			if self.TexturesReversed then v.RT = "TOPRIGHT"
			elseif v.RT == nil then v.RT = "TOPLEFT" end
			
		 self.F[k]:SetSize(v.W, v.H)
			
			local x1, x2, y1, y2 = v.tX / g.W, (v.tX + v.W) / g.W, v.tY / g.H, (v.tY + v.H) / g.H

   -- x1,y1               x2,y1
   --                          
   --
   --
   -- x1,y2               x2,y2
   
   if self.TexturesReversed then
	 	 self.F[k]:SetPoint(v.RT, -v.X - self.tO.X, v.Y + self.tO.Y)
    --                                         UL, LL, UR, LR
			 self.F[k]:SetTexCoord(x2, y1, x2, y2, x1, y1, x1, y2)
   elseif v.Rotate then
 		 self.F[k]:SetPoint(v.RT, v.X + self.tO.X, v.Y + self.tO.Y)
    
--    local ULx, ULy, LLx, LLy, URx, URy, LRx, LRy = x1, y1, x1, y2, x2, y1, x2, y2
    local URx, URy, LRx, LRy, LLx, LLy, ULx, ULy = x2, y1, x2, y2, x1, y2, x1, y1
    

    local i = v.Rotate
    while i > 0 do
     local t1, t2 = ULx, ULy
     ULx, ULy = LLx, LLy
     LLx, LLy = LRx, LRy
     LRx, LRy = URx, URy
     URx, URy = t1, t2
     i = i - 1
    end
    
    self.F[k]:SetTexCoord(ULx, ULy, LLx, LLy, URx, URy, LRx, LRy)
   

		 else
 		 self.F[k]:SetPoint(v.RT, v.X + self.tO.X, v.Y + self.tO.Y)
			 self.F[k]:SetTexCoord(x1, x2, y1, y2)
    if v.Rotation then self.F[k]:SetRotation(v.Rotation) end
			end
	  self.F[k]:Show()
			if v.Clr then self.F[k]:SetVertexColor(v.Clr.r, v.Clr.g, v.Clr.b, v.Clr.a) end
		end
 end

end

function SkyBaseClass.prototype:MaxChars(txt, maxlen)
 while txt:GetStringWidth() > maxlen do txt:SetText(strsub(txt:GetText(), 0, #txt:GetText()-1)) end
end

function SkyBaseClass.prototype:SetText_Justified(f, t, lvl, j, maxlen) -- frame, text, level, justification, maxlength
 if lvl then maxlen = maxlen - 15 end
 self.F[f]:SetText(t)
 self:MaxChars(self.F[f], maxlen)
 
 -- PetName nil 0 left 60
 if self.TexturesReversed then self.F[f]:SetText(lvl .. " " .. self.F[f]:GetText())
 else self.F[f]:SetText(self.F[f]:GetText() .. " " .. lvl) end
 
 local w = self.F[f]:GetStringWidth()
 if j == "CENTER" then w = w / 2 elseif j == "LEFT" then w = 0 end
-- w = w + o

 if self.TexturesReversed then self.F[f]:SetPoint("TOPRIGHT", -self.Txt[f].X - self.tO.X + w, self.Txt[f].Y + self.tO.Y)
 else self.F[f]:SetPoint("TOPLEFT", self.Txt[f].X + self.tO.X - w, self.Txt[f].Y + self.tO.Y) end  
 

end

function SkyBaseClass.prototype:AddText()
 if not self.Txt or not self.F then return end

 for k,v in pairs(self.Txt) do
	 self.F[k] = self.F:CreateFontString(self.BaseName .. self.Name .. k, "OVERLAY")
  self.F[k]:SetFont(v.Font, v.Size, v.Flags)
		self.F[k]:ClearAllPoints()
		
		if self.TexturesReversed then v.RT = "TOPRIGHT"
		elseif v.RT == nil then v.RT = "TOPLEFT" end

		if self.TexturesReversed then
		 self.F[k]:SetPoint(v.RT, -v.X - self.tO.X, v.Y + self.tO.Y)
   self.F[k]:SetJustifyH("RIGHT")
  else
		 self.F[k]:SetPoint(v.RT, v.X + self.tO.X, v.Y + self.tO.Y)
		end
		self.F[k]:SetText(v.String)
		self.F[k]:Show()
	end

end

SkyUI.Page = {
	["Druid"] = "[bonusbar:1] 1; [bonusbar:2] 2; [bonusbar:3] 3; [bonusbar:4] 4;",
	["Warrior"] = "[bonusbar:1] 1; [bonusbar:2] 2; [bonusbar:3] 3;",
	["Rogue"] = "[bonusbar:1] 1;",
	["Priest"] = "[bonusbar:1] 1;",
	["DEFAULT"] = "[bonusbar:0] 0; [bonusbar:5] 5; [bonusbar:1,stealth:1] 2; [overridebar][possessbar] possess;",
}


function SkyBaseClass.prototype:GetBar()
	local condition = SkyUI.Page["DEFAULT"]
	local class = UnitClass("player")

	local page = SkyUI.Page[class]
	if page then
		condition = condition.." "..page
	end
	condition = condition.." 0"

	return condition
end

function SkyBaseClass.prototype:CreateFrame()
	self.F = CreateFrame("Frame", self.BaseName .. self.Name, UIParent)
    self.F:SetPoint(self.RT, self.X, self.Y)
	self.F:SetSize(self.W, self.H)
	self.F:Show()
	self.F.sui = self
end

function SkyBaseClass.prototype:MakeMovable()
 
-- local f = self.F
-- f:EnableMouse(true)
-- local t = self.F:CreateTexture(nil, "OVERLAY")
-- t:SetTexture(1, 0, 0, 0.3) -- SpriteSheet
-- t:SetAllPoints(f)

-- t:SetPoint("TOPLEFT", f, "TOPLEFT", -20, 0)
-- t:SetSize(50, 50)
 end

function SkyBaseClass.prototype:CreateSecureHeader()
	self.Header = CreateFrame("Frame", nil, nil, "SecureHandlerStateTemplate")

 if self.Name == "KeyPad" then
 RegisterStateDriver(self.Header, "page", self.GetBar()) 
 self.Header:SetAttribute("_onstate-page", [[

		if newstate == "possess" or newstate == "11" then
			if HasVehicleActionBar() then
				newstate = GetVehicleBarIndex()
			elseif HasOverrideActionBar() then
				newstate = GetOverrideBarIndex()
			elseif HasTempShapeshiftActionBar() then
				newstate = GetTempShapeshiftBarIndex()
			else
				newstate = nil
			end
			if not newstate then -- cannot determine possess/vehicle action bar page
				newstate = 12
			end
		end
  
		self:SetAttribute("state", newstate)
		control:ChildUpdate("state", newstate)
 ]])
 
 end
 
 self.Header:SetPoint(self.RT, self.X, self.Y)
	self.Header:SetSize(self.W, self.H)
	self.Header:Show()
	self.Header.sui = self
 end

function SkyBaseClass.prototype:ConfigLoaded()

end

SkyUI.Modules.Main.OnConfigUpdated = function()
 SkyUI.Modules.UnitFrames.OnConfigUpdated()
end




function SkyUI_UpdateConfigs()
--  print(SkyUI.Config.UnitFrames.Enabled)
-- tcopy(SkyUI.Config, SkyUI.ConfigDefaults)
-- SkyUI.Config.UnitFrames.targettarget.Enabled = true
 if SkyUI.OnConfigLoaded then SkyUI.OnConfigLoaded() end

 if SkyUI.Config.UnitFrames.UI.Enabled then SkyUI.Modules.UnitFrames.Enable() end
 if SkyUI.Config.ActionBars.UI.Enabled then SkyUI.Modules.ActionBars.Enable() end
end
 
local function SkyUI_Unload()
 SkyUI.tcopy(SkyUIConfig, SkyUI.Config)
end

local function EventManager(self, evt, ...)
 if evt == "PLAYER_ENTERING_WORLD" then
  if SkyUI.SkyCombos and SkyUI.Specs.ComboPoints.Enabled then SkyUI.SkyCombos:new() end
 elseif evt == "ADDON_LOADED" and ... == "SkyUI" then
  if not SkyUIConfig then
   SkyUIConfig = {}
   SkyUI.tcopy(SkyUIConfig, SkyUI.ConfigDefaults)
  -- SavedVariable Change Updates
  elseif SkyUIConfig.ActionBars.UI.HotKeys == nil then SkyUIConfig.ActionBars.UI.HotKeys = SkyUI.ConfigDefaults.ActionBars.UI.HotKeys
  elseif SkyUIConfig.ActionBars.UI.MacroText == nil then SkyUIConfig.ActionBars.UI.MacroText = SkyUI.ConfigDefaults.ActionBars.UI.MacroText
  elseif SkyUIConfig.ActionBars.UI.ItemCount == nil then SkyUIConfig.ActionBars.UI.ItemCount = SkyUI.ConfigDefaults.ActionBars.UI.ItemCount
  end
--  SkyUI.tcopy(SkyUIConfig, SkyUI.ConfigDefaults)
  SkyUI.tcopy(SkyUI.Config, SkyUIConfig)
  SkyUI_UpdateConfigs()
  self:UnregisterEvent("ADDON_LOADED")
 elseif evt == "PLAYER_LOGOUT" then SkyUI_Unload() end
end

local evt = CreateFrame("Frame") -- Event Catcher Frame
evt:RegisterEvent("PLAYER_ENTERING_WORLD")
evt:RegisterEvent("ADDON_LOADED") -- Fired when saved variables are loaded
evt:RegisterEvent("PLAYER_LOGOUT")

evt:SetScript("OnEvent", EventManager)
 
 
 
 
 
 
-- DEFAULT_CHAT_FRAME:AddMessage(UIParent:GetEffectiveScale());
-- ChatFrame:Hide()
--MinimapCluster:Hide()

